<!doctype html>
<html>
    <head>
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

        <title>reveal.js</title>

        <link rel="stylesheet" href="css/reset.css">
        <link rel="stylesheet" href="css/reveal.css">
        <link rel="stylesheet" href="css/theme/black.css" id="theme">

        <!-- Theme used for syntax highlighting of code -->
        <link rel="stylesheet" href="lib/css/monokai.css">

        <!-- Printing and PDF exports -->
        <script>
            var link = document.createElement( 'link' );
            link.rel = 'stylesheet';
            link.type = 'text/css';
            link.href = window.location.search.match( /print-pdf/gi ) ? 'css/print/pdf.css' : 'css/print/paper.css';
            document.getElementsByTagName( 'head' )[0].appendChild( link );
        </script>

    </head>
    <body>
        <div style="background:green; left:0; right:0; position:absolute; height:30px;">
            <div style="text-align: center;">(U)Unclassified</div>
        </div>
        <div class="reveal">
            <div class="slides">
                <section>
                    <section>
                        <h1>
                            Functions
                        </h1>
                    </section>
                    <section>
                        <h2>Functions Overview</h2>
                        <ul>
                            <li>Function Scope</li>
                            <li>Parameters and Arguments
                                <ul>
                                    <li>Command Line Arguments</li>
                                    <li>Returning</li>
                                    <li>Pass By Reference</li>
                                </ul>
                            </li>
                            <li>Lambda Functions</li>
                            <li>List Comprehension</li>
                            <li>Closures, Iterators and Generators</li>
                        </ul>
                    </section>
                    <section>
                        <h2>Objectives</h2>
                        <a href="../objectives.html" target="_blank">Functions Objectives</a>
                    </section>
                </section>
                <section>
                    <section>
                        <h2>Scope</h2>
                        <ul>
                            <li>
                                The Scope determines the visibility of variables in your program                        
                            </li>
                        </ul>
                    </section>
                </section>
                <section>
                    <section>
                        <h2>
                            LEGB Rule
                        </h2>
                        <ul>
                            <li>
                                In Python we use the <b>LEGB Rule:</b>
                            </li>
                        </ul>
                        <img src="../../assets/scope_resolution_1.png">
                    </section>
                    <section>
                        <h3>Local</h3>
                        <ul>
                            <li>
                                Refers to variables defined within the function
                            </li>
                        </ul>
                        <pre>
<code class="Python" data-trim data-noescape>
def sales_tax(amount):
    rate = 0.0625  <b># Local Variable</b>
    tax_total = amount * rate <b># Rate can be seen here</b>
    total = tax_total + amount
    print(total)

# Call function and pass parameter
sales_tax(200)  <b># Rate cannot be seen here</b>
</code>
                        </pre>
                    </section>
                    <section>
                        <h3>Enclosing-Function Global</h3>
                        <ul>
                            <li>
                                Refers to variables defined within local scope of functions wrapping other functions
                            </li>
                        </ul>
                        <pre>
<code class="Python" data-trim data-noescape>
    def program():
        amount = 200 <b># Enclosing-Function Global variable</b>
        def sales_tax(amount):
            rate = 0.0625
            tax_total = amount * rate <b># Amount can be seen here</b>
            total = tax_total + amount
            print(total)

        sales_tax(200) <b># Amount could be seen here</b>
        
    program() <b># Amount could not be seen here</b>
</code>
                        </pre>
                    </section>
                    <section>
                        <h3>Global/Module</h3>
                        <ul>
                            <li>
                            Variables defined at the top level of files and modules
                            </li>
                        </ul>
                        <pre>
<code class="Python" data-trim data-noescape>
amount = 200 <b>#Global Variable</b>

def sales_tax(amount):
    rate = 0.0625  <b># Local Variable</b>
    tax_total = amount * rate <b># Rate can be seen here</b>
    total = tax_total + amount
    print(total)

# Did not pass parameter
sales_tax(200)
</code>
                        </pre>
                    </section>
                    <section>
                        <h3>Built-In</h3>
                        <ul>
                            <li>
                                Loaded into scope when interpreter starts
                            </li>
                            <li>
                                For Example:
                            </li>
                        </ul>
                        <pre>
<code data-trim data-noescape>
hash()
min()
dict()
print()
</code>
                        </pre>
                    </section>
                </section>
                <section>
                    <section>
                        <h2>
                            Modifying Global Variables
                        </h2>
                        <p>
                            We can use the global keyword to grant access to global variables
                        </p>
                    </section>
                    <section>
                        <h3>Modifying Global Variables Example</h3>
                        <pre>
<code class="Python" style="font-size:15px;line-height: 16px;" data-trim data-noescape>
a = 1

def f():
    print('Inside f() : ', a)  # Uses global because there is no local 'a'

def g():    
    a = 2  # Uses local variable a
    print('Inside g() : ', a)

def h():    
    global a  # Uses global keyword to access the global a, allowing modification
    a = 3
    print('Inside h() : ',a)

# Global scope
print('global : ', a)
f()
print('global : ', a)
g()
print('global : ', a)
h()
print('global : ', a)
</code>
                        </pre>
                    </section>
                    <section>
                        <h3>Modifying Global Variables Output</h3>
                        <pre>
<code data-trim data-noescape>
global :  1
Inside f() :  1
global :  1
Inside g() :  2
global :  1
Inside h() :  3
global :  3
</code>
                        </pre>
                    </section>
                </section>

                <section>
                    <section>
                        <h2>
                            User Functions
                        </h2>
                        <ul>
                            <li>Python functions are blocks of reusable code</li>
                            <li>Functions are meant to split up the code into functionally organized <b>reusable</b> code</li>
                            <li>In Python, you do <b>not</b> have to return a value</li>
                        </ul>
                    </section>
                    <section>
                        <h3>
                            Defining a Function
                        </h3>
                        <pre>
<code class="Python" data-trim data-noescape>
def function_name(parameters):
    x = 0 # What we want to return

    return x # What we return
</code>
                        </pre>
                    </section>
                    <section>
                        <h3>
                            Function with a return value
                        </h3>
                        <pre>
<code class="Python" data-trim data-noescape>
def name_upper(name):
    name = name*2
    return name # Return Value

print(name_upper('Cao')) # Function call
</code>
                        </pre>
                    </section>
                    <section>
                        <h3>
                            Function without a return value
                        </h3>
                        <pre>
<code class="Python" data-trim data-noescape>
def name_upper(name):
    # Your Code
    print(name)
</code>
                        </pre>
                    </section>
                </section>
                <section>
                    <section>
                        <h2>
                            Calling a Function
                        </h2>
                        <ul>
                            <li>Call the function name</li>
                            <li>Pass in any needed argument</li>
                            <li>If the function returns a value, direct the return value to a variable</li>
                        </ul>
                        <pre>
<code class="Python" data-trim data-noescape>
# Lets print a name
print_name('SrA. Snuffy')
</code>
                        </pre>
                    </section>
                    <section>
                        <h4>Function Example</h4>
                        <pre>
<code class="Python" data-trim data-noescape>
def divisible_by(num, amount): # Function Definition        
    i = 1.0
    while (num / i >= 1 and amount > 0):
        if num % i == 0:
            print("{} divided by {} equals: {}".format(num, i, num / i))
            amount -= 1
        i += 1

divisible_by(900, 10) # Function Call
</code>
                        </pre>
                    </section>
                </section>
                <section>
                    <section>
                        <h2>User Functions Labs</h2>
                        <a href="lab4a.html">Lab 4A</a>
                    </section>
                </section>
                <section>
                    <section>
                        <h2>
                            Parameters and Arguments
                        </h2>
                        <ul>
                            <li>Parameters are defined within the parentheses</li>
                            <li>They are undefined variables that you want to use within the function</li>
                        </ul>
                        <ul>
                            <li>Arguments are defined variables that you pass on the function call.</li>
                        </ul>                        
                    </section>
                    <section>
                        <h3>
                            Parameter and Argument Example
                        </h3>
                        <pre>
<code class="Python" data-trim data-noescape>
def sales_tax(amount): # function and parameter 'amount'
    rate = 0.0625
    tax_total = amount * rate
    total = tax_total + amount
    print(total)

sales_tax(200) # Function call and argument 200
</code>
                        </pre>
                    </section>
                    <section>
                        <h3>
                            Default Parameters
                        </h3>
                        <pre>
<code class="Python" data-trim data-noescape>
def divisible_by(num, amount = 5):
    i = 1.0
    while (num / i >= 1 and amount > 0):
        if num % i == 0:
            print("{} divided by {} equals: {}".format(num, i, num / i))
            amount -= 1
        i += 1

divisible_by(900, 10)
</code>
                        </pre>
                    </section>
                    <section>
                        <pre>
<code class="Python" data-trim data-noescape>
# Checks all numbers that can be divided into num
# up until amount has been reached or we reach divide by self
def divisible_by(num, amount=None):
    if amount is None:
        amount = 5

    i = 1.0
    while (num / i >= 1 and amount > 0):
        if num % i == 0:
            print("{} divided by {} equals: {}".format(num, i, num / i))
            amount -= 1
        i += 1

divisible_by(900)
</code>
                        </pre>
                    </section>
                </section>
                <section>
                    <section>
                        <h3>
                            Copies vs. References
                        </h3>
                        <ul>
                            <li>
                                Objects are never copied into functions they are (called by) reference to the original objects value
                            </li>
                            <li>
                                If we modify the passed reference (only possible with mutable objects), it modifies the original object
                            </li>
                            <li>
                                If we assign an entirely new value to either immutable/mutable objects, we will get a new object
                            </li>
                        </ul>
                    </section>
                    <section>
                        <h3>
                            Example of Modification
                        </h3>
                        <pre>
<code class="Python" data-trim data-noescape>
x = [1,2,3,4]    # create a global list

def test(x):
    x[1] = 20      # modifying the mutable object via indexing
    x.append(50)   # modifying the mutable object via method

test(x)

print(x)

# output: 1,20,3,4,50
</code>
                        </pre>
                    </section>
                    <section>
                        <h3>Example of Name Binding</h3>
                        <pre>
<code class="Python" data-trim data-noescape>
x = [1,2,3,4] # here we create a global list

def test(x):
    x = [1,2,3,4,5]
    x.append(200)

test(x)

print(x)

# output: 1,2,3,4
</code>
                        </pre>
                    </section>
                </section>
                <section>
                    <section>
                        <h3>
                            Args and Kwargs
                        </h3>
                        <ul>
                            <li>*args are used to pass a keyword-less, variable-length argument list.</li>
                            <li>**kwargs is used to pass a keyword, variable-length argument list.</li>
                            <li>A keyword argument is where you provide a name to the variable as you pass it into the function.</li>
                            <li>kwargs are placed in dictionaries.</li>
                        </ul>
                    </section>
                    <section>
                        <h3>Args and Kwargs Example</h3>
                        <pre>
<code class="Python" data-trim data-noescape>
def my_func1(*args):
    for arg in args:
        print('arg: ', arg)
        print(type(args))

def my_func2(**kwargs):
    for key, value in kwargs.items():
        print(key, value)

my_func1('two', 3, 'four', 5)
my_func2(a = 12, b = 'abc')
</code>
                        </pre>
                    </section>
                </section>
                <section>
                    <section>
                        <h3>
                            Command Line Arguments
                        </h3>
                        <p>
                            Arguments can also be passed through the command line or terminal.
                        </p>
                    </section>
                    <section>
                        <h4>
                            Old Way Example
                        </h4>
                        <pre>
<code class="Python" data-trim data-noescape>
import sys

args = str(sys.argv)
print(sys.argv[0]) # The name of the program is always argv[0]

for i in range(len(sys.argv)):
    print('args[%d]: %s' % (i, sys.argv[i]))

# Input Example: python3 test.py hello world "Hello World"
# What is the output?
</code>
                        </pre>
                    </section>
                    <section>
                        <h4>
                            New Way Example
                        </h4>
                        <pre>
<code class="Python" data-trim data-noescape>
import argparse

parser = argparse.ArgumentParser(description='This is a demo')
parser.add_argument('-i','--input',help='Input arg', required=True)
args = parser.parse_args()

print(args.input)

# Input Example: python3 test.py -i test
</code>
                        </pre>
                    </section>
                </section>
                <section>
                    <section>
                        <h3>Returning</h3>
                        <ul>
                            <li>
                                With functions, you have the choice to return a variable
                            </li>
                            <li>
                                This is done so that the function becomes it's own local scope
                            </li>
                        </ul>
                    </section>
                    <section>
                        <h3>Returning Example</h3>
                        <pre>
<code class="Python" data-trim data-noescape>
def create_initials(first_name, last_name):
    initials = first_name[0].upper() + last_name[0].upper()
    return initials

initials = create_initials("jack", "black")
test_value = print(initials)

print(test_value)
</code>
                        </pre>
                    </section>
                </section>
                <section>
                    <section>
                        <h3>Pass by reference</h3>
                        <ul>
                            <li>Pass by Object Reference means that objects passed to the functions are referenced</li>
                            <li>Python does this by default</li>
                        </ul>
                    </section>
                    <section>
                        <pre>
<code class="Python" data-trim data-noescape>
#Define the function
def append_one(a):
    a.append(1)

# Declare and set a variable
a = [0]

# Pass that variable by reference to the function append_one()
append_one(a)
print(a)

# Since the function acted on a mutable variable... 
# the contents of the object were changed.
[0, 1]
</code>
                        </pre>
                    </section>
                </section>
                <section>
                    <section>
                        <h2>ARGS and Parameters Labs</h2>
                        <a href="lab4b.html">Labs 4B</a>
                    </section>
                </section>
                <section>
                    <section>
                        <h2>
                            Lambda Functions
                        </h2>
                        <ul>
                            <li>Lambdas, are anonymous functions - functions without a name.</li>
                            <li>Lambda functions are passed as arguments to higher-order functions</li>
                        </ul>
                    </section>
                    <section>
                        <h3>
                            Lambda Features
                        </h3>
                        <ul style="font-size:35px">
                            <li>Lambda functions can take any number of arguments</li>
                            <li>Return only one value in the form of an expression</li>
                            <li>They cannot contain commands or multiple expressions</li>
                            <li>Lambda functions have their own namespace</li>
                        </ul>
                    </section>
                    <section>
                        <h3>
                            Lambda Function Example
                        </h3>
                        <pre>
<code class="Python" data-trim data-noescape>
my_list = range(26)

print(my_list)
print(filter(lambda x: x % 2 == 0, my_list))
</code>
                        </pre>
                        <ul style="font-size: 25px;">
                            <li><b>lambda</b> : the keyword to create a lambda</li>
                            <li><b>x</b> : the parameter. Multiple parameters ex: lambda x,y,z:</li>
                            <li><b>x % 2 == 0</b> : the execution code</li>
                            <li><b>my_list</b> : the argument. Multiple args ex: lambda x,y,z: code, input1, input2, key</li>
                        </ul>    
                        <pre>
<code class="Python" data-trim data-noescape>
# Multiple arg/param lambda: 
lambda x,y,z: (x + y) - z, input1, input2, key
</code>
                        </pre>
                    </section>
                    <section>
                        <h3>Lambda Breakdown</h3>
                        <pre>
<code class="Python" data-trim data-noescape>
#Define a regular function
def reg_function(x):
    return x**2

# Make it one line
def reg_function(x): return x**2

# Turn it into a lambda
new_stuff = lambda x: x**2
</code>
                        </pre>
                    </section>
                    <section>
                        <h3>Lambda Common uses</h3>
                            <pre>
<code class="Python" data-trim data-noescape>
# Map applies a function to all the items in an input_list. 
# That function can be a lambda.
map()

# Filter creates a list of elements for which a function 
# returns true.
filter()

# Reduce accepts a function and a sequence and returns a 
# single calculated value.
reduce()
</code>
                            </pre>
                    </section>
                </section>
                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                    <h2>Lambda Functions Labs</h2> 
                    <a href="lab4c.html">Labs 4C</a>
                </section>
                <section>
                    <section>
                        <h2>List Comprehension</h2>
                        <ul>
                            <li>Python supports something called "list comprehension", which allows us to write minimal, easy and readable lists</li>
                            <li>This way you can put everything in a one liner</li>
                        </ul>
                    </section>
                    <section>
                        <h4>Normal List</h4>
                        <pre>
<code class="Python" data-trim data-noescape>
a_list = [1,2,3,4,5]

def square_list(a_list):
    a = []
    for item in a_list:
        a.append(item*item)
    return a

print(square_list(a_list))

# Output
[1, 4, 9, 16, 25]
</code>
                        </pre>
                    </section>
                    <section>
                        <h4>Normal List with Refactoring</h4>
                        <pre>
<code class="Python" data-trim data-noescape>
a_list = [1,2,3,4,5]

def square_list(a_list):
    for i in range(len(a_list)):
        a_list[i] *= a_list[i]

square_list(a_list)
print(a_list)

# Output
[1, 4, 9, 16, 25]
</code>
                        </pre>
                    </section>
                    <section>
                        <h4>List Comprehension without Conditional</h4>
                        <pre>
<code class="Python" data-trim data-noescape>
a_list = [1,2,3,4,5]

def square_list(a_list):
    return [x*x for x in a_list]

print(square_list(a_list))

#Output 
[1, 4, 9, 16, 25]
</code>
                        </pre>
                    </section>
                    <section>
                        <h4>List Comprehension with Conditional</h4>
                        <pre>
<code class="Python" data-trim data-noescape>
a_list = [1,2,3,4,5]

def square_list(a_list):
    return [x*x for x in a_list if x % 2 == 0]

print(square_list(a_list))

# Output
[4, 16]                                
</code>
                        </pre>
                    </section>
                    <section>
                        <h4>Set Comprehension with Conditional</h4>
                        <pre>
<code class="Python" data-trim data-noescape>
a_list = [1,2,3,4,5]

def square_list(a_list):
    return {x*x for x in a_list if x % 2 == 0}

print(square_list(a_list))

# Output
set([16, 4])
</code>
                        </pre>
                    </section>
                    <section>
                        <h4>Dictionary Comprehension</h4>
                        <pre>
<code class="Python" data-trim data-noescape>
my_dict = {'a': 1, 'b': 2, 'c': 3, 'd': 4, }

squared_dict = {k:v*v for (k,v) in my_dict.items()}
print(squared_dict)
</code>
                        </pre>
                    </section>
                </section>
                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                    <h2>List Comprehensions Labs</h2>
                    <a href="lab4d.html">Labs 4D</a>
                </section>

                <section>
                    <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                        <h2>Recursion</h2>
                        <p>Recursion is a function that calls itself until a condition is met</p>
                        <pre>
<code class="Python" data-trim data-noescape>
# This program has a recursive function.
def message():
    print('This is a recursive function.')
    message()

message()

</code>
                        </pre>
                    </section>
                    <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                        <pre>
<code class="Python" data-trim data-noescape>
Program Output

This is a recursive function.
This is a recursive function.
This is a recursive function.
This is a recursive function.

</code>
                        </pre>
                    </section>
                    <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                        <pre>
<code class="Python" data-trim data-noescape>
def countdown(n):
    if n <= 0:
        print('Blastoff!')
    else:
        print(n)
        countdown(n-1)

</code>
                        </pre>
                    </section>
                    <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                        <h4>Function call</h4>
                        <pre>
<code class="Python" data-trim data-noescape>
>>> countdown(3)

</code>
                        </pre>
                    </section>
                    <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                        <h4>Function call</h4>
                        <pre>
<code class="Python" data-trim data-noescape>
3
2
1
Blastoff!

</code>
                        </pre>
                    </section>
                    <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                        <h4>Base Case and Recursive Case</h4>
                        <ul>
                            <li>Base Case
                                <ul>
                                    <li>If the problem can be solved now, then the function solves it and returns</li>
                                </ul>
                            </li>
                            <li>Recursive Case
                                <ul>
                                    <li>If the problem cannot be solved now, then the function reduces it to smaller similar problems and calls itself to solve the smaller problem.</li>
                                </ul>
                            </li>
                        </ul>
                    </section>
                </section>
                <section>
                    <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                        <h4>Recursive program</h4>
                        <pre>
<code class="Python" data-trim data-noescape>
# This program has a recursive function.
def message(times):
    if times > 0:
        print('This is a recursive function.')
        message(times - 1)

# By passing the argument 5 to the message function we are
# telling it to display the message five times.
message(5)
</code>
                        </pre>
                    </section>
                    <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                        <h4>Recursive Output</h4>
                        <pre>
<code class="text" data-trim data-noescape>
Program Output

This is a recursive function.
This is a recursive function.
This is a recursive function.
This is a recursive function.
This is a recursive function.

</code>
                        </pre>
                    </section>
                    <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                        <h4>Problem solving with Recursion</h4>
                            <p>A problem can be solved with recursion if it can be broken down into smaller problems that are identical in structure to the overall problem.</p>
                            <p>Any problem that can be solved recursively can also be solved with a loop.</p>
                    </section>
                    <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                        <h4>Repetitive problems</h4>
                        <ul>
                            <li>If the problem can be solved now, without recursion, then the function solves it and returns</li>

                            <li>If the problem cannot be solved now, then the function reduces it to a smaller but similar problem and calls itself to solve the smaller problem</li>
                        </ul>
                    </section>
                    <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                        <h4>Using Recursion to Calculate the Factorial of a Number</h4>
                        <pre>
<code class="Python" data-trim data-noescape>
If n = 0 then   n! = 1
If n > 0 then   n! = 1 x 2 x 3 x  . . . x n
</code>
                        </pre>
                    </section>
                    <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                        <h4>Using Recursion to Calculate the Factorial of a Number</h4>
                        <pre>
<code class="Python" data-trim data-noescape>
If n  = 0 then       factorial(n) = 1
If n  > 0 then       factorial(n) = 1 x 2 x 3 x  . . .  x  n
</code>
                        </pre>
                    </section>
                    <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                        <h4>Base Case</h4>
                        <pre>
<code class="Python" data-trim data-noescape>
If n = 0 then       factorial(n) = 1
</code>
                        </pre>
                        <h4>Recursive Case</h4>
                        <pre>
<code class="Python" data-trim data-noescape>
If n > 0 then       factorial(n) = n x factorial(n - 1)
</code>
                        </pre>
                    </section>
                    <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                        <h4>Recursion program to Calculate the factorial of a number</h4>
                        <pre>
<code class="Python" data-trim data-noescape>
1  # This program uses recursion to calculate
2  # the factorial of a number.
3
4  def main():
5      # Get a number from the user.
6      number = int(input('Enter a nonnegative integer: '))
7
8      # Get the factorial of the number.
9      fact = factorial(number)
10
11      # Display the factorial.
12      print('The factorial of', number, 'is', fact)
13
</code>
                        </pre>
                    </section>
                    <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                        <h4>Using Recursion to Calculate the Factorial of a Number</h4>
                        <pre>
<code class="Python" data-trim data-noescape>
14  # The factorial function uses recursion to
15  # calculate the factorial of its argument,
16  # which is assumed to be nonnegative.
17  def factorial(num):
18      if num == 0:
19          return 1
20      else:
21          return num * factorial(num - 1)
22
23  # Call the main function.
24  main()
</code>
                        </pre>
                    </section>
                    <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                        <h4>Using Recursion to Calculate the Factorial of a Number</h4>
                        <pre>
<code class="text" data-trim data-noescape>
Program Output 

Enter a nonnegative integer: 4 
The factorial of 4 is 24
</code>
                        </pre>
                    </section>
                    <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                        <h4>Using Recursion to Calculate the Factorial of a Number</h4>
                        <pre>
<code class="Python" data-trim data-noescape>
return num * factorial(num - 1)
</code>
                        </pre>
                    </section>
                    <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                        <h4>Direct and Indirect Recursion</h4>
                        <ul>    
							<li>Direct - calls itself</li>
                            <li>Indirect - Function A calls Function B, which calls Function C, which calls Function A.</li>
						</ul>
                    </section>
                    <section data-background-image="images/org_symbol.png" style="font-size:35px;" data-background-size="8%" data-background-position="top 5% left 1%">
                        <h4>Checkpoint</h4>
                        <ol>
							<li>It is said that a recursive algorithm has more overhead than an iterative algorithm. What does this mean?</li>
                        	<li>What is a base case?</li>
                        	<li>What is a recursive case?</li>
                        	<li>What causes a recursive algorithm to stop calling itself?</li>
                        	<li>What is direct recursion? What is indirect recursion?</li>
                        </ol>
                    </section>
                    <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                        <h4>Examples of Recursive Algorithms</h4>
                    </section>
                    <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                        <h4>What will the following program display?</h4>
                        <pre>
<code class="Python" data-trim data-noescape>
def show_me(arg):
    if arg < 10:
        show_me(arg + 1)
    else:
        print(arg)

num = 0
show_me(num)
</code>
                        </pre>
                    </section>
                    <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                        <h4>What will the following program display?</h4>
                        <pre>
<code class="Python" data-trim data-noescape>
def show_me(arg):
    print(arg)
    if arg 10:
        show_me(arg + 1)
num = 0
show_me(num)
</code>
                        </pre>
                    </section>
                    <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                        <h4>The following function uses a loop. Rewrite it as a recursive function that performs the same operation.</h4>
                        <pre>
<code class="Python" data-trim data-noescape>
def traffic_sign(n):
    while n > 0:
        print('No Parking')
        n = n > 1
</code>
                        </pre>
                    </section>
                    <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                        <h4>Recursion to find factorial of a number</h4>
                        <p>
                            Lets take a look at solving for n!. As a quick reminder n! is defined as:
                        </p>
                        <pre>
<code class="Python" data-trim data-noescape>
n! = n x (n-1) x (n-2) x (n-3) x...x 3 x 2 x 1
4! = 4 x 3 x 2 x 1 = 24
    
Base case:
    If n = 0 then   n! = 1
or  If n = 0 then   factorial(n) = 1

Recursive case:
    If n > 0 then   n! = 1 x 2 x 3 x ... n
or  If n > 0 then   factorial(n) = n x factorial(n-1)
                            
</code>
                        </pre>
                    </section>
                    <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                        <h3>
                            Python Translation:
                        </h3>
                        <pre>
<code class="Python" data-trim data-noescape>
def recursive_factorial(n):
    #base case
    if n == 0:
        return 1
    #recursive case
    else:
        return n * recursive_factorial(n-1)                    
</code>
                        </pre>
                    </section>
                </section>
                <section>
                    <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                        <h4>Endless Recursion</h4>
                        <p>
                            Be sure that every time you write a recursive function that you can control the number of times it will be executed.
                        </p>
                        <pre>
<code class="Python" data-trim data-noescape>
# Endless recursion
def forever_recursion():
    annoying_message()

def annoying_message():
    print('Nudge Nudge, Wink Wink, Say No More Say No More')
    forever_recursion()

forever_recursion()                                        
</code>
                        </pre>
                    </section>
                </section>
                <section>
                    <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                        <h4>Recursion for the Fibonacci Series</h4>
                        <p style="font-size:30px">
                            A very common way to present recursion is by writing a program to calculate Fibonacci numbers. After the second number, every number in the series is the sum of the two previous numbers. The sequence is the following:
                            0,1,1,2,3,5,8,13,21,34,55,89,144,233,...
                        </p>
                        <pre>
<code class="text" data-trim data-noescape>
A recursive function can have multiple base cases. 
Both of them return a value without making a recursive call.
                                            
Base case:
    If n = 0 then   fibonacci(n) = 0
    If n = 1 then   fibonacci(n) = 1

Recursive case:
    If n > 1 then   fibonacci(n) = fibonacci(n-1) + fibonacci(n-2)
</code>
                        </pre>
                    </section>
                    <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                        <h4>Translate to Python</h4>
                        <pre>
<code class="Python" data-trim data-noescape>
def fibonacci(n):
    if n == 0:
        return 0
    elif n == 1:
        return 1
    else:
        return fibonacci(n-1) + fibonacci(n-2)
</code>
                        </pre>
                    </section>
                </section>

                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                    <h2>Labs</h2>
                    <a href="lab4e.html">Lab 4E</a>
                </section>
                
                <section>
                    <section>
                        <h2>Closures</h2>
                        <ul>
                            <li>A Closure is a function object that remembers values in enclosing scopes</li> 
                            <li>If you have written a function that returned another function</li>
                        </ul>
                    </section>
                    <section>
                        <h3>Closure Example</h3>
                        <pre>
<code class="Python" data-trim data-noescape>
def generate_power_func(n):

    def nth_powah(x):
        return x**n
    
    return nth_powah
# Stores the nested function/closure
x = generate_power_func(10)

# removing the outside function
del generate_power_func

# Can still access the nth_powah
print(x(2))
                            </code>
                        </pre>
                    </section>
                    <section>
                        <h4>Why use Closures</h4>
                        <ul>
                            <li>Closures can avoid the use of global values and provide some form of data hiding.</li>
                            <li>They provide a layer of simplicity</li>
                        </ul>
                    </section>
                    <section>
                        <h4>Why to avoid Closures</h4>
                        <ul>
                            <li>They are harder to debug</li>
                            <li>They may not always be cleaner</li>
                            <li>They can get complex quickly</li>
                        </ul>
                    </section>
                </section>
                <section>
                    <section>
                        <h2>Iterators</h2>
                        <ul>
                            <li>An iterator is an object with a state that remembers where it is during iteration</li>
                            <li>Building your own iterator means that you can save memory space</li>
                        </ul>
                    </section>
                    <section>
                        <h3>Iterator Example</h3>
                        <pre>
<code class="Python" data-trim data-noescape>
>>> x = iter([1, 2, 3, 4])
>>> print(x)
&lt;list_iterator object at 0x0000029C29CA6A00&gt;
next(x)
1
next(x)
2
next(x)
3
next(x)
4
next(x)
StopIteration
</code>
                        </pre>
                    </section>
                </section>
                <section>
                    <section>
                        <h2>Generators</h2>
                        <ul>
                            <li>A generator is a function that produces a sequence of values to iterate through rather than a single value.</li>
                            <li>Yield is similar to return; however yield produces a sequence of values.</li>
                            <li>If there is a yield in the body of the function then it is a generator.</li>
                        </ul>
                    </section>
                    <section>
                        <h3>Generators Example</h3>
                        <pre>
<code class="Python" data-trim data-noescape>
def yrange(n):
    i = 0
    while i < n:
        yield i
        i += 1

my_gen = yrange(10)
print(my_gen)

for i in my_gen:
    print(i)
</code>
                        </pre>
                    </section>
                    <section>
                        <h4>Generators Output</h4>
                        <pre>
<code class="Python" data-trim data-noescape>
# output
&lt;generator object yrange at 0x007F3328&gt;
0
1
2
3
4
5
6
7
8
9
</code>
                        </pre>
                    </section>
                </section>
                <section>
                    <section>
                        <h2>Questions?</h2>                
                    </section>    
                </section>
                <section>
                    <section>
                        <h2>Summary</h2>
                        <ul>
                            <li>Function Scope
                                <ul>
                                    <li>Local</li>
                                    <li>Enclosed</li>
                                    <li>Global</li>
                                    <li>Built-In</li>
                                    <li>Modification of Global Variables</li>
                                </ul>
                            </li>
                            <li>User Functions</li>
                            <li>Calling Functions</li>
                        </ul>
                    </section>
                    <section>
                        <ul>
                            <li>Parameters and arguments
                            <ul>
                                <li>Parameters</li>    
                                <li>arguments</li>    
                                <li>Copy vs Reference</li>
                                <li>Modification of Parameters</li>
                                <li>Default Parameters</li>
                                <li>Command-Line Arguments</li>
                                <li>Returning</li>
                                <li>Pass By Reference</li>
                            </ul>
                        </ul>
                    </section>
                    <section>
                        <ul>
                            <li>Lambda Functions</li>
                            <ul>
                                <li>Lambda Function Features</li>
                                <li>Lambda Function Breakdown</li>
                                <li>CommonUses</li>
                            </ul>
                            <li>List Comprehension</li>
                            <ul>
                                <li>Normal List</li>
                                <li>Normal List with Refactoring</li>
                                <li>List Comprehension without Conditional</li>
                                <li>List Comprehension with Conditional</li>
                                <li>Comprehension with Conditional</li>
                                <li>Dictionary Comprehension</li>
                            </ul>
                        </ul>
                    </section>
                    <section>
                        <ul>
                            <li>Closures</li>
                            <ul>
                                <li>How to use Closures</li>
                                <li>Closure Risks</li>
                            </ul>
                            <li>Iterators</li>
                            <ul>
                                <li>How to use Iterators</li>
                            </ul>
                            <li>Generators</li>
                        </ul>
                    </section>
                </section>
            </div>
        </div>
        <footer style="background:green; left:0; right:0; bottom: 0; position:absolute; height:30px;">
            <div style="text-align: center;">(U)Unclassified</div>
        </footer>    
            
        <script src="js/reveal.js"></script>

        <script>
            // More info about config & dependencies:
            // - https://github.com/hakimel/reveal.js#configuration
            // - https://github.com/hakimel/reveal.js#dependencies
            Reveal.initialize({
                hash: true,
                menu: {
                    // Specifies which side of the presentation the menu will 
                    // be shown. Use 'left' or 'right'.
                    side: 'left',

                    // Specifies the width of the menu.
                    // Can be one of the following:
                    // 'normal', 'wide', 'third', 'half', 'full', or
                    // any valid css length value
                    width: 'normal',

                    // Add slide numbers to the titles in the slide list.
                    // Use 'true' or format string (same as reveal.js slide numbers)
                    numbers: true,

                    // Specifies which slide elements will be used for generating
                    // the slide titles in the menu. The default selects the first
                    // heading element found in the slide, but you can specify any
                    // valid css selector and the text from the first matching
                    // element will be used.
                    // Note: that a section data-menu-title attribute or an element
                    // with a menu-title class will take precedence over this option
                    titleSelector: 'h1, h2, h3, h4, h5, h6',

                    // If slides do not have a matching title, attempt to use the
                    // start of the text content as the title instead
                    useTextContentForMissingTitles: false,

                    // Hide slides from the menu that do not have a title.
                    // Set to 'true' to only list slides with titles.
                    hideMissingTitles: false,

                    // Adds markers to the slide titles to indicate the 
                    // progress through the presentation. Set to 'false'
                    // to hide the markers.
                    markers: true,

                    // Specify custom panels to be included in the menu, by
                    // providing an array of objects with 'title', 'icon'
                    // properties, and either a 'src' or 'content' property.
                    custom: false,

                    // Specifies the themes that will be available in the themes
                    // menu panel. Set to 'true' to show the themes menu panel
                    // with the default themes list. Alternatively, provide an
                    // array to specify the themes to make available in the
                    // themes menu panel, for example...
                    // [
                    //     { name: 'Black', theme: 'css/theme/black.css' },
                    //     { name: 'White', theme: 'css/theme/white.css' },
                    //     { name: 'League', theme: 'css/theme/league.css' }
                    // ]
                    themes: true,

                    // Specifies the path to the default theme files. If your
                    // presentation uses a different path to the standard reveal
                    // layout then you need to provide this option, but only
                    // when 'themes' is set to 'true'. If you provide your own 
                    // list of themes or 'themes' is set to 'false' the 
                    // 'themesPath' option is ignored.
                    themesPath: 'css/theme/',

                    // Specifies if the transitions menu panel will be shown.
                    // Set to 'true' to show the transitions menu panel with
                    // the default transitions list. Alternatively, provide an
                    // array to specify the transitions to make available in
                    // the transitions panel, for example...
                    // ['None', 'Fade', 'Slide']
                    transitions: true,

                    // Adds a menu button to the slides to open the menu panel.
                    // Set to 'false' to hide the button.
                    openButton: true,

                    // If 'true' allows the slide number in the presentation to
                    // open the menu panel. The reveal.js slideNumber option must 
                    // be displayed for this to take effect
                    openSlideNumber: true,

                    // If true allows the user to open and navigate the menu using
                    // the keyboard. Standard keyboard interaction with reveal
                    // will be disabled while the menu is open.
                    keyboard: true,

                    // Normally the menu will close on user actions such as
                    // selecting a menu item, or clicking the presentation area.
                    // If 'true', the sticky option will leave the menu open
                    // until it is explicitly closed, that is, using the close
                    // button or pressing the ESC or m key (when the keyboard 
                    // interaction option is enabled).
                    sticky: true,

                    // If 'true' standard menu items will be automatically opened
                    // when navigating using the keyboard. Note: this only takes 
                    // effect when both the 'keyboard' and 'sticky' options are enabled.
                    autoOpen: true,

                    // If 'true' the menu will not be created until it is explicitly
                    // requested by calling RevealMenu.init(). Note this will delay
                    // the creation of all menu panels, including custom panels, and
                    // the menu button.
                    delayInit: false,

                    // If 'true' the menu will be shown when the menu is initialised.
                    openOnInit: false,

                    // By default the menu will load it's own font-awesome library
                    // icons. If your presentation needs to load a different
                    // font-awesome library the 'loadIcons' option can be set to false
                    // and the menu will not attempt to load the font-awesome library.
                    loadIcons: true
                },
                dependencies: [
                    { src: 'plugin/markdown/marked.js' },
                    { src: 'plugin/markdown/markdown.js' },
                    { src: 'plugin/highlight/highlight.js' },
                    { src: 'plugin/notes/notes.js', async: true },
                    { src: 'node_modules/reveal.js-menu/menu.js' }
                ]
            });
        </script>
    </body>
</html>
